/* Coloriage dans une matrice de int            */

public class ColoriageRecursifEnConsole {

  static void cercle(int px,int py,int r,int [][] t,int coul) {
    int dx;
    int dy;
    for ( int l = 0 ; l < t.length ; l++ ) {
      for ( int c = 0 ; c < t[0].length ; c++ ) {
        dx = px-c;
        dy = py-l;
        if ( dx*dx+dy*dy < r*r ) {
          t[l][c] = coul; } } }
  }

/* Fonction de creation d'une matrice de int    */
/* a 0 initialisee avec deux cercles de int     */
/* aux valeurs 1 et 2                           */

  static int [][] initMatrice(int colonnes,int lignes) {
    int [][] tab = new int[lignes][colonnes];
    cercle(20,10,9,tab,1);
    cercle(40,15,11,tab,2);
    cercle(30,12,6,tab,3);
    return tab;
  }

/* Fonction d'affichage des valeurs contenues   */
/* dans une matrice de int                      */

  static void affichageMatrice(boolean [][] t) {
    for ( int i = 0 ; i < t.length ; i++ ) {
      for ( int j = 0 ; j < t[0].length ; j++ ) {
        if ( t[i][j] ) {
          Console.afficher("  X"); }
          else {
          Console.afficher("  O"); } }
      Console.sautDeLigne(); }
  }

/* Fonction d'affichage des valeurs contenues   */
/* dans une matrice de int                      */

  static void affichageMatrice(int [][] t) {
    for ( int i = 0 ; i < t.length ; i++ ) {
      for ( int j = 0 ; j < t[0].length ; j++ ) {
        Console.formater("%1d",t[i][j]); }
      Console.sautDeLigne(); }
  }

//////////////////////////////////////////////////

/* Fonction recursive de coloriage d'une zone   */
/* de pixels de valeurs identiques              */

  static void coloriageRecursif(int px,int py,int [][] t,
                                int c,int ct) {
    if ( ( px >= 0 ) && ( px < t[0].length ) &&
         ( py >= 0 ) && ( py < t.length ) ) {
      if ( ( t[py][px] != c ) && ( t[py][px] == ct ) ) {
        t[py][px] = c;
        coloriageRecursif(px+1,py,t,c,ct);
        coloriageRecursif(px-1,py,t,c,ct);
        coloriageRecursif(px,py+1,t,c,ct);
        coloriageRecursif(px,py-1,t,c,ct); } }
  }

/* Fonction de coloriage d'une zone de pixels   */
/* de valeurs identiques                        */

  static void coloriage(int px,int py,int [][] t,int c) {
    coloriageRecursif(px,py,t,c,t[py][px]);
  }

/* Fonction recursive de remplissage d'une zone */
/* de pixels delimitee par une valeur           */

  static void remplissageRecursif(int px,int py,int [][] t,
                                  int c,int cl) {
    if ( ( px >= 0 ) && ( px < t[0].length ) &&
         ( py >= 0 ) && ( py < t.length ) ) {
      if ( ( t[py][px] != c ) && ( t[py][px] != cl ) ) {
        t[py][px] = c;
        remplissageRecursif(px+1,py,t,c,cl);
        remplissageRecursif(px-1,py,t,c,cl);
        remplissageRecursif(px,py+1,t,c,cl);
        remplissageRecursif(px,py-1,t,c,cl); } }
  }

//////////////////////////////////////////////////

/* Menu principal                               */

  static int menuPrincipal() {
    int v;
    Console.sautDeLigne();
    Console.afficherln("1: Colorier une tache");
    Console.afficherln("2: Colorier une zone delimitee");
    Console.afficherln("0: Quitter");
    Console.afficher("Que voulez vous faire ? ");
    v = Console.saisirInt();
    Console.sautDeLigne();
    return v;
  }

/* Programme principal                          */

  public static void main(String [] args) {
    Console.setTitle("ColoriageRecursif");
    int [][] t = initMatrice(60,20);
    Console.afficherln("Image avant dessin");
    affichageMatrice(t);
    Console.sautDeLigne();
    int px;
    int py;
    int c;
    int cl;
    int choix;
    choix = menuPrincipal();
    while ( choix != 0 ) {
      switch (choix) {
        case 1 : {
          Console.afficher("Position en x du germe ? ");
          px = Console.saisirInt();
          Console.afficher("Position en y du germe ? ");
          py = Console.saisirInt();
          Console.afficher("Couleur de trace       ? ");
          c = Console.saisirInt();
          coloriage(px,py,t,c);
          Console.sautDeLigne();
          Console.afficherln("Image après dessin");
          affichageMatrice(t); }
          break;
        case 2 : {
          Console.afficher("Position en x du germe ? ");
          px = Console.saisirInt();
          Console.afficher("Position en y du germe ? ");
          py = Console.saisirInt();
          Console.afficher("Couleur de trace       ? ");
          c = Console.saisirInt();
          Console.afficher("Couleur limite         ? ");
          cl = Console.saisirInt();
          remplissageRecursif(px,py,t,c,cl);
          Console.sautDeLigne();
          Console.afficherln("Image après dessin");
          affichageMatrice(t); }
          break; }
    choix = menuPrincipal(); }
  }
}